%{!?scl:%global pkg_name %{name}}
%{?scl:%scl_package rubygem-%{gem_name}}
%global gem_name bson_ext

%global gem_dir /opt/rh/ruby193/root/usr/local/share/gems
%global gem_extdir /opt/rh/ruby193/root/usr/local/%{_lib}/gems/exts/%{gem_name}-%{version}/ext/%{gem_name}/%{gem_name}
%global rubyabi 1.9.1

Summary: C extensions for Ruby BSON
Name: %{?scl:%scl_prefix}rubygem-%{gem_name}
Version: 1.8.1
Release: 2%{?dist}
Group: Development/Languages
License: ASL 2.0
URL: http://www.mongodb.org/display/DOCS/BSON
Source0: http://rubygems.org/gems/%{gem_name}-%{version}.gem

Requires: %{?scl:%scl_prefix}rubygem(bson) >= 1.5.2
Requires: %{?scl:%scl_prefix}ruby
Requires: %{?scl:%scl_prefix}ruby(rubygems)
BuildRequires: %{?scl:%scl_prefix}ruby
BuildRequires: %{?scl:%scl_prefix}ruby-devel
BuildRequires: %{?scl:%scl_prefix}rubygems
BuildRequires: %{?scl:%scl_prefix}rubygems-devel
# for tests:
BuildRequires: %{?scl:%scl_prefix}rubygem(bson) >= 1.5.2
BuildRequires: %{?scl:%scl_prefix}rubygem(shoulda)
BuildRequires: %{?scl:%scl_prefix}rubygem(mocha)
BuildRequires: %{?scl:%scl_prefix}rubygem(json)
Provides: %{?scl:%scl_prefix}rubygem(%{gem_name}) = %{version}

%define gembuilddir %{buildroot}%{gem_dir}

%description
C extensions to accelerate the Ruby BSON serialization. For more information
about BSON, see http://bsonspec.org.  For information about MongoDB, see
http://www.mongodb.org.


%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}


%prep
%{?scl:scl enable %scl "}
gem unpack %{SOURCE0}
%setup -q -D -T -n  %{gem_name}-%{version}

gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec
%{?scl:"}

%build
mkdir -p .%{gem_dir}
%{?scl:scl enable %scl - << \EOF}
# Create the gem as gem install only works on a gem file
gem build %{gem_name}.gemspec

export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
# gem install compiles any C extensions and installs into a directory
# We set that to be a local directory so that we can move it into the
# buildroot in %%install
gem install -V \
        --local \
        --install-dir .%{gem_dir} \
        --bindir .%{_bindir} \
        --force \
        --rdoc \
        %{gem_name}-%{version}.gem
%{?scl:EOF}


%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}/

mkdir -p %{buildroot}%{gem_extdir}/ext/%{gem_name}
mv %{buildroot}%{gem_instdir}/ext/%{gem_name}/%{gem_name}/cbson.so %{buildroot}%{gem_extdir}

# clean yardoc leftovers
rm -rf %{buildroot}/%{gem_instdir}/.yardoc

# Remove the binary extension sources and build leftovers.
rm -rf %{buildroot}%{gem_instdir}/ext
rm -f %{buildroot}%{gem_instdir}/.require_paths

%check
#Tests temporarily not executed in check
#pushd %{_tmppath}
#tar xzvf %{SOURCE1}
##remove the inclusion of bson (absolute path that doesn't exist) and rather require it while running ruby
#sed -i '1d' ./test/bson/test_helper.rb
#%{?scl:scl enable %scl - << \EOF}
#ruby -rubygems -I%{buildroot}%{gem_extdir}/ -e "require 'bson';Dir.glob('test/bson/*_test.rb').each {|t| require t}"
#%{?scl:EOF}
#popd
#rm -rf %{_tmppath}/test


%files
%doc %{gem_instdir}/LICENSE
%doc %{gem_instdir}/VERSION
%dir %{gem_instdir}
%{gem_dir}/cache/%{gem_name}-%{version}.gem
%{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
%dir %{gem_extdir}
%{gem_extdir}/cbson.so

%files doc
%doc %{gem_docdir}
%{gem_instdir}/bson_ext.gemspec

%changelog
* Mon Feb 04 2013 Troy Dawson <tdawson@redhat.com> - 1.8.1-2
- Fix the gem_extdir, again

* Mon Jan 14 2013 Troy Dawson <tdawson@redhat.com> - 1.8.1-1
- Updated to version 1.8.1
- Updated spec to do fedora 18+ gem packaging

* Wed Nov 14 2012 Troy Dawson <tdawson@redhat.com> - 1.5.2-8
- Fix the gem_extdir

* Sat Sep 29 2012 Troy Dawson <tdawson@redhat.com> - 1.5.2-6
- Release bump for rebuild into both i386 and x86_64

* Mon Jun 11 2012 Troy Dawson <tdawson@redhat.com> - 1.5.2-5
- Changed ruby_sitearch to be gem_extdir

* Mon Jun 11 2012 Troy Dawson <tdawson@redhat.com> - 1.5.2-4
- Changed spec file to work with scl
- Rebuilt for scl

* Fri Jan 27 2012 Troy Dawson <tdawson@redhat.com> - 1.5.2-1
- Updated to 1.5.2

* Fri Sep 23 2011 bkabrda <bkabrda@redhat.com> - 1.4.0-2
- Moved test cleanup to check section.

* Thu Sep 22 2011 Bohuslav Kabrda <bkabrda@redhat.com> - 1.4.0-1
- Version 1.4.0 (removed the fix for failing tests, as it is now in upstream).

* Tue Sep 20 2011 Bohuslav Kabrda <bkabrda@redhat.com> - 1.3.1-2
- Added the fix for failing tests on i386 (should be fixed in 1.4.0, so it can be removed then) -
  see https://github.com/mongodb/mongo-ruby-driver/commit/e613880922beaf1e80274aa183aa5ac0a9d09ac4

* Thu Sep 08 2011 Bohuslav Kabrda <bkabrda@redhat.com> - 1.3.1-1
- Initial package
